### gamemodes/tick_game

# countdown delay scores
scoreboard players remove @s[scores={rightClick=1..}] rightClick 1
scoreboard players remove @s[scores={cooldown=1..},tag=!sprinter] cooldown 1
scoreboard players remove @s[scores={autoDelay=1..}] autoDelay 1
scoreboard players remove @s[scores={autoReload=1..,coas=..0},tag=!sprinter] autoReload 1

# save gun stats to storage
data remove storage gun gunStats
data modify storage gun gunStats set from entity @s SelectedItem.tag.gunStats

# reloading stuff
execute if entity @s[predicate=cod:guns/is_in_offhand] run function cod:guns/input/offhand
execute if score @s relRepeat matches 1.. run function cod:guns/reload/tick_reload
execute if entity @s[scores={autoReload=1,relRepeat=..0}] run function cod:guns/reload/start_auto_reload

# changing weapon stuff
execute store result score .gunId gunStats run data get storage gun gunStats.id
execute unless score .gunId gunStats = @s gunId run function cod:guns/input/swap
scoreboard players operation @s gunId = .gunId gunStats

# sprinting stuff
execute if entity @s[predicate=cod:guns/is_sprinting] run function cod:guns/input/sprint
execute if entity @s[scores={sprintRecovery=1..},predicate=!cod:guns/is_sprinting] run function cod:guns/sprint/stopping_sprint

# reset cmd
execute if entity @s[scores={cmdLast=1,cooldown=..0,relRepeat=..0},tag=!sprinter] unless score .gunId gunStats matches 0 run function cod:guns/cmd/reset_cmd

# shooting stuff
execute if score @s coas matches 1.. run function cod:guns/input/right_click
execute if entity @s[advancements={cod:guns/clicked_spyglass=true}] run function cod:guns/input/spyglass_click
execute if entity @s[scores={autoDelay=..0,autoFire=1..}] run function cod:guns/shoot/start_burst
execute if entity @s[scores={rightClick=1..,cooldown=..0,relRepeat=..0},tag=!sprinter] run function cod:guns/shoot/start_shoot

## equipment

# countdown delay scores
scoreboard players remove @s[scores={holdEq=1..}] holdEq 1

# throwing
execute if entity @s[advancements={cod:guns/equip/clicked_eye=true}] run function cod:guns/input/eye_click
execute if entity @s[scores={holdEq=1,cooldown=..0}] run function cod:guns/equip/throw/start_throw

## save stats

# save stats
execute if score .statsNotSaved gunStats matches 1 if score .gunId gunStats matches 1.. run function cod:guns/stats/save_stats

# set stats loaded score to 0
scoreboard players set .reloadStatsLoaded gunStats 0
scoreboard players set .ammoStatsLoaded gunStats 0
scoreboard players set .shootStatsLoaded gunStats 0
scoreboard players set .classStatsLoaded gunStats 0